import matplotlib.pyplot as plt
import matplotlib.pyplot as plt
import numpy as np


def F(x,d):
  return (1-d)* (1-d) *(1-2*x) + x - 2*(1-d) * (x * (1-x) * d * (2-d))**0.5

def G(x,d):
  return -2*(1-d)**2 + 1 -  (1-d) * (d * (2-d))**0.5  * (1-2*x)/(x * (1-x))**0.5

def H(x):
  return ((x * x + 4)- x * (x * x + 4)** 0.5) /(2 * (x * x + 4))

def I(c,d):
  return (np.exp(-c) - 2*(1-d)**2 + 1)/((1-d) * (d*(2-d))**0.5 )


delta = 0.001
xrange = np.arange(0, 1, delta)
yrange = np.arange(0, 1, delta)
X, Y = np.meshgrid(xrange, yrange)

#fig = plt.figure(dpi=250)
fig = plt.figure(figsize=(4,4),dpi=300)

#alpha = 3
c = 0.3
delta2 = 0.02
t = H(I(c,delta2))
b = 1 - t + F(t,delta2)/G(t,delta2)


Z = 1-(Y * (1-X))**0.5 - (X * (1-Y))**0.5 -delta2
Z3 = (1 - X) - np.exp(c) * Y - b
Z4 = X - np.exp(c) * (1 - Y) - b
#Z5 = (1 - X) - np.exp(delta - (np.log(delta2)) / (alpha - 1)) * Y - delta2
#Z6 = X - np.exp(delta - (np.log(delta2)) / (alpha - 1)) * (1 - Y) - delta2
plt.contour(X, Y, Z, [0], colors = 'black')
plt.plot(X[Z <= 0], Y[Z <= 0], color='gray', alpha=0.5)
#ct1=plt.contour(X, Y, Z2, [0], colors='black',linestyles='dashed',labels='line1')
plt.contour(X, Y, Z3, [0], colors='black')
plt.contour(X, Y, Z4, [0], colors='black')
#plt.contour(X, Y, Z5, [0], colors='black',linestyles='dashdot',labels='line2')
#plt.contour(X, Y, Z6, [0], colors='black',linestyles='dashdot')

#plt.plot(X[Z3 <= 0], Y[Z3 <= 0], color='blue', alpha=0.1)
plt.axis([0, 1, 0, 1])
plt.xlabel("x (Type I error)")
plt.ylabel("y (Type II error)")

plt.gca().set_aspect('equal', adjustable='box')
plt.show()
